﻿# /usr/bin/perl -w
# Adam に書いてもらったプログラム．
# Homo sampiens を含んだ配列をファイルから除去する．


use strict;

# outfiles\_fol があれば削除する．
if (-d "outfiles\_fol") {
system("rm -r outfiles\_fol")
  }

# outfiles\_fol がなければ作成する．
if (!-d "outfiles\_fol") {
mkdir("outfiles\_fol", 0755) || die "Cannot make outfiles\_fol"
  }
  
my @files = glob ("ENSG*");							#glob command will copy file names (only) from the folder and insert them into an array

#print "@files \n";									#print the names of the files

my @fileData;										#new array to hold contents of each file as strings



######first loop to put contents of each file into a new array ###########

for (my $i = 0; $i<scalar @files; ++ $i) {			
	$fileData[$i] = getfiledata ($files[$i]);		#use the getfile subroutine
    # print "\n$files[$i]\n";
    # print "|$fileData[$i]\n|\n";
	}
# print "|@fileData|\n";



###### Main program: perform search for Homo in each file ###########

for (my $i = 0; $i<scalar @fileData; ++ $i) {			#loop through fileData array
	my @fileArray = split("\n",$fileData[$i]);			#convert fileData from string to array, split at line returns, so we can search for Homo
	
	#print $file."\n\n";								#print just to see the file
	
	for (my $i = 0; $i<scalar @fileArray; ++ $i) {		#loop through fileData array
		
		if ( $fileArray[$i] =~ /Homo/) {				#if array element contains "Homo" anywhere, then delete elements
 			delete @fileArray[$i];						#delete names line．$fileArray[$i] でも同じだと思う．
 			delete @fileArray[$i+1];					#delete data line
		}
	}
	

    my $outfile = "outfiles\_fol/out\_@files[$i]";						#stores name of output file (nothing in it yet).
	
	open (OUT,">outfiles\_fol/out\_@files[$i]");						#> will replace, >> will append
	
	for (my $i = 0; $i<scalar @fileArray; ++ $i) {		#loop through fileData array to print all elements with Homo excluded to the new file
 		print OUT @fileArray[$i]."\n";
		}

    
}														#exit loop, finished




#########################SUBROUTINES##################################################
sub getfiledata {

	# a subroutine to get the data from a file
	# stored data in a scalar
	
	my ($filename, $separator) = @_;
	my $save_input_separator = $/;
	my ($contents);	# the contents of the file;
	
	unless (open(FILE, $filename)) {
		print "Cannot open file \"$filename\".  Exiting now...\n";
		exit;
	}

	$/ = $separator;
	
	$contents = <FILE>;
	
	close FILE;
	
	return $contents;

}